Attribute VB_Name = "Module1"
Option Explicit

Type Zeitformat
 Stunden As Integer '00-24
 Minuten As Integer '00-60
End Type
Type KE
 Start As Zeitformat 'Standart: 00:00
 AnzFilme As Integer '0-25
 KassettenName As String
 Lnge As Zeitformat
 ReadOnly As Boolean
End Type
Type KF
 Lnge As Zeitformat
 FilmName As String
 SenderName As String
 Infos As String
End Type
Global KassettenEigenschaften(1 To 100) As KE
Global KassettenFilm(1 To 100, 1 To 25) As KF
Global AktKassette As Integer
Global AktFilm As Integer
Global AnzKassetten As Integer '0-100
Global Sender(1 To 100) As String
Global AnzSender As Integer '0-100
Global Verz As String
Global Const SenderDatei$ = "Sender.dat"
Global Const KassettenDatei$ = "Kassetten.dat"

Function ZeitformatToString(Zeit As Zeitformat) As String
 ZeitformatToString = Right$("00" + LTrim$(RTrim$(Str$(Zeit.Stunden))), 2) + ":" + Right$("00" + LTrim$(RTrim$(Str$(Zeit.Minuten))), 2)
End Function
Function StringToZeitformat(ByVal Text As String, Fehler As Boolean, Optional Vorgegeben As Integer = 0, Optional MakeErrorMessage As Boolean = True) As Zeitformat
 'Vorgegeben
 ' 0 (nichts)
 ' 1 (Stunden)
 ' 2 (Minuten)
 Text = LTrim$(RTrim$(Text))
 If Text = "" Then
  If MakeErrorMessage Then MsgBox "Das Zeitformat ist ungltig.", , "Fehler"
  Fehler = True
  Exit Function
 End If
 Dim F As Integer
 For F = 1 To Len(Text)
  If Mid$(Text, F, 1) = "," Then
   Text = Left$(Text, F - 1) + "." + Right$(Text, Len(Text) - F)
  End If
 Next
 Dim Zeit As Zeitformat
 Zeit.Minuten = 0
 Zeit.Stunden = 0
 Fehler = False
 F = InStr(Text, ":")
 If F = 0 Then
  If Vorgegeben = 0 Then
   If MakeErrorMessage Then MsgBox "Das Zeitformat ist ungltig.", , "Fehler"
   Fehler = True
   Exit Function
  End If
  Do While (Left$(Text, 1) = "0") And (Len(Text) > 1)
   Text = Right$(Text, Len(Text) - 1)
  Loop
  If Vorgegeben = 1 Then
   If CheckZahl(Text, True) = False Then
    If MakeErrorMessage Then MsgBox "Das Zeitformat ist ungltig.", , "Fehler"
    Fehler = True
    Exit Function
   End If
  ElseIf Vorgegeben = 2 Then
   If CheckZahl(Text, False) = False Then
    If MakeErrorMessage Then MsgBox "Das Zeitformat ist ungltig.", , "Fehler"
    Fehler = True
    Exit Function
   End If
  End If
  If Vorgegeben = 1 Then
   If (Val(Text) >= 25) Or (Val(Text) < 0) Then
    If MakeErrorMessage Then MsgBox "Das Zeitformat ist ungltig.", , "Fehler"
    Fehler = True
    Exit Function
   End If
   If CheckForKomma(Val(Text)) Then
    Dim TempZahl As Double
    TempZahl = (Val(Text) - Int(Val(Text))) * 60
    If CheckForKomma(TempZahl) Then
     If MakeErrorMessage Then MsgBox "Das Zeitformat ist ungltig.", , "Fehler"
     Fehler = True
     Exit Function
    End If
    Zeit.Minuten = TempZahl
    Text = Str$(Val(Text) - TempZahl / 60)
   End If
   Zeit.Stunden = Val(Text)
  ElseIf Vorgegeben = 2 Then
   If (Val(Text) > 60 * 24) Or (Val(Text) < 0) Then
    If MakeErrorMessage Then MsgBox "Das Zeitformat ist ungltig.", , "Fehler"
    Fehler = True
    Exit Function
   End If
   Do While Val(Text) >= 60
    Zeit.Stunden = Zeit.Stunden + 1
    Text = Str$(Val(Text) - 60)
   Loop
   Zeit.Minuten = Val(Text)
  Else
   If MakeErrorMessage Then MsgBox "Das Zeitformat ist ungltig.", , "Fehler"
   Fehler = True
   Exit Function
  End If
 Else
  Dim Zahl1 As String
  Dim Zahl2 As String
  Zahl1 = LTrim$(RTrim$(Left$(Text, F - 1)))
  Zahl2 = LTrim$(RTrim$(Right$(Text, Len(Text) - F)))
  Do While (Left$(Zahl1, 1) = "0") And (Len(Zahl1) > 1)
   Zahl1 = Right$(Zahl1, Len(Zahl1) - 1)
  Loop
  Do While (Left$(Zahl2, 1) = "0") And (Len(Zahl2) > 1)
   Zahl2 = Right$(Zahl2, Len(Zahl2) - 1)
  Loop
  If (CheckZahl(Zahl1) = False) Or (CheckZahl(Zahl2) = False) Then
   If MakeErrorMessage Then MsgBox "Das Zeitformat ist ungltig.", , "Fehler"
   Fehler = True
   Exit Function
  End If
  If ((Zahl1 > 24) Or (Zahl1 < 0)) Or ((Zahl2 > 59) Or (Zahl2 < 0)) Then
   If MakeErrorMessage Then MsgBox "Das Zeitformat ist ungltig.", , "Fehler"
   Fehler = True
   Exit Function
  End If
  Zeit.Stunden = Val(Zahl1)
  Zeit.Minuten = Val(Zahl2)
 End If
 StringToZeitformat = Zeit
End Function
Function CheckZahl(ByVal Zahl As String, Optional Komma As Boolean = False) As Boolean
 If Komma Then
  CheckZahl = (Zahl = LTrim$(RTrim$(Str$(Val(Zahl)))))
 Else
  CheckZahl = (Zahl = LTrim$(RTrim$(Str$(Int(Val(Zahl))))))
 End If
End Function
Sub SaveKassetten()
 Dim FileNum%
 Dim X As Integer
 Dim Y As Integer
 FileNum% = FreeFile
 Open Verz + KassettenDatei$ For Output As FileNum%
 For X = 1 To AnzKassetten
  Print #FileNum%, KassettenEigenschaften(X).KassettenName
  Print #FileNum%, ZeitformatToString(KassettenEigenschaften(X).Start)
  Print #FileNum%, ZeitformatToString(KassettenEigenschaften(X).Lnge)
  Print #FileNum%, Str$(KassettenEigenschaften(X).AnzFilme)
  For Y = 1 To KassettenEigenschaften(X).AnzFilme
   Print #FileNum%, KassettenFilm(X, Y).FilmName
   Print #FileNum%, KassettenFilm(X, Y).SenderName
   Print #FileNum%, ZeitformatToString(KassettenFilm(X, Y).Lnge)
   Print #FileNum%, KassettenFilm(X, Y).Infos
  Next
 Next
 Close FileNum%
End Sub
Sub SaveSender()
 Dim FileNum%
 Dim X As Integer
 FileNum% = FreeFile
 Open Verz + SenderDatei$ For Output As FileNum%
 For X = 1 To AnzSender
  Print #FileNum%, Sender(X)
 Next
 Close FileNum%
End Sub

Function AddiereZeit(Zeit1 As Zeitformat, Zeit2 As Zeitformat) As Zeitformat
 Dim Zeit3 As Zeitformat
 Zeit3.Stunden = Zeit1.Stunden + Zeit2.Stunden
 Zeit3.Minuten = Zeit1.Minuten + Zeit2.Minuten
 If Zeit3.Minuten > 60 Then
  Zeit3.Stunden = Zeit3.Stunden + 1
  Zeit3.Minuten = Zeit3.Minuten - 60
 End If
 AddiereZeit = Zeit3
End Function

Function CheckForKomma(ByVal Zahl As Double) As Boolean
 CheckForKomma = ((Zahl = Int(Zahl)) = False)
End Function

Sub TauscheKassette(Kassette1 As Integer, Kassette2 As Integer)
 Dim TempKassette As KE
 ReDim TempKassetteFilm(1 To 25) As KF
 TempKassette = KassettenEigenschaften(Kassette1)
 Dim X As Integer
 For X = 1 To 25
  TempKassetteFilm(X) = KassettenFilm(Kassette1, X)
 Next
 KassettenEigenschaften(Kassette1) = KassettenEigenschaften(Kassette2)
 For X = 1 To 25
  KassettenFilm(Kassette1, X) = KassettenFilm(Kassette2, X)
 Next
 KassettenEigenschaften(Kassette2) = TempKassette
 For X = 1 To 25
  KassettenFilm(Kassette2, X) = TempKassetteFilm(X)
 Next
End Sub

Sub TauscheSender(Sender1 As Integer, Sender2 As Integer)
 Dim Temp As String
 Temp = Sender(Sender1)
 Sender(Sender1) = Sender(Sender2)
 Sender(Sender2) = Temp
End Sub
